param 
(
	$Username = "",
	$Password = ""
)

Import-Module MSOnline -Force

$SecurePassword = ConvertTo-SecureString $Password -AsPlainText -Force
$Creds = New-Object System.Management.Automation.PSCredential $Username, $SecurePassword

Connect-MsolService -Credential $Creds

$Threshold = 0

$Users = Get-MsolUser -MaxResults 50000 -DomainName company.com

if ($Users.Count -lt $Threshold)
{
	throw "Less users than expected returned from MSOnline"
}

#Always pass objects as hash table in pipeline
foreach ($User in $Users)
{
    $obj = @{}
    $obj.Add("UPN", $User.UserPrincipalName)
    $obj.Add("objectClass", "user")
    $obj.Add("IsLicensed", $User.IsLicensed)
    if($user.IsLicensed)
    {
    if($User.Licenses.AccountSkuId[0].EndsWith("FACULTY"))
    {$obj.Add("LicenseType", "Staff")}
    elseif($User.Licenses.AccountSkuId[0].EndsWith("STUDENT"))
    {$obj.Add("LicenseType", "Student")}
    elseif($User.Licenses.AccountSkuId[0].EndsWith("ALUMNI"))
    {$obj.Add("LicenseType", "Alumni")}
    else {$obj.Add("LicenseType", "Unknown")}
    }
    $obj
}
